"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useAnimatedHashMap = useAnimatedHashMap;
var React = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function useAnimatedHashMap(_ref) {
  let {
    routes,
    index
  } = _ref;
  const refs = React.useRef({});
  const previous = refs.current;
  const routeKeys = Object.keys(previous);
  if (routes.length === routeKeys.length && routes.every(route => routeKeys.includes(route.key))) {
    return previous;
  }
  refs.current = {};
  routes.forEach((_ref2, i) => {
    let {
      key
    } = _ref2;
    refs.current[key] = previous[key] ?? new _reactNative.Animated.Value(i === index ? 0 : i >= index ? 1 : -1);
  });
  return refs.current;
}
//# sourceMappingURL=useAnimatedHashMap.js.map